Imports System
Imports Microsoft.Win32.SafeHandles
Imports System.Runtime.InteropServices

Namespace WinUsbDemo
	'''  <summary>
	'''  API declarations relating to file I/O (and used by WinUsb).
	'''  </summary>

	Friend NotInheritable Class FileIo
		Friend NotInheritable Class NativeMethods

			Private Sub New()
			End Sub

			Friend Const FILE_ATTRIBUTE_NORMAL As Int32 = &H80
			Friend Const FILE_FLAG_OVERLAPPED As Int32 = &H40000000
			Friend Const FILE_SHARE_READ As Int32 = 1
			Friend Const FILE_SHARE_WRITE As Int32 = 2
			Friend Const GENERIC_READ As UInt32 = &H80000000L
			Friend Const GENERIC_WRITE As UInt32 = &H40000000
			Friend Const INVALID_HANDLE_VALUE As Int32 = -1
			Friend Const OPEN_EXISTING As Int32 = 3

			<DllImport("kernel32.dll", SetLastError := True, CharSet := CharSet.Unicode)> _
			Friend Shared Function CreateFile(ByVal lpFileName As String, ByVal dwDesiredAccess As UInt32, ByVal dwShareMode As Int32, ByVal lpSecurityAttributes As IntPtr, ByVal dwCreationDisposition As Int32, ByVal dwFlagsAndAttributes As Int32, ByVal hTemplateFile As IntPtr) As SafeFileHandle
			End Function
		End Class
	End Class

End Namespace
